// searchController.js

const mysql = require('mysql');

// Créez une connexion à la base de données
const db = mysql.createConnection({
    host: process.env.DATABASE_HOST,
    user: process.env.DATABASE_USER,
    password: process.env.DATABASE_PASSWORD,
    database: process.env.DATABASE
});

// Fonction pour insérer les données de recherche dans la base de données
exports.insertSearchData = (userId, articleTitle1, articleTitle2, callback) => {
    db.query('INSERT INTO search (id, article1, article2) VALUES (?, ?, ?)', [userId, articleTitle1, articleTitle2], (error, result) => {
        if (error) {
            console.error('Erreur lors de l\'insertion des données dans la base de données :', error);
            // Vous pouvez gérer l'erreur en appelant le callback avec l'erreur
            callback(error, null);
        } else {
            // Les données ont été insérées avec succès
            console.log('Données insérées avec succès dans la base de données.');
            // Appelez le callback avec succès
            callback(null, result);
        }
    });
};
